/*
    Copyright 2004,2005,2006 Luigi Auriemma

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    http://www.gnu.org/licenses/gpl.txt

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>



#define VER                 "0.1.1"
#define DNS4ME_PROXY_DATA   "DNS4MeRocksDNS2G"
#define KEYPATH1            "Software\\Rhino Software\\DNS4Me Client\\Proxy"
#define BUFFSZ              4096



void doquery(HKEY key, u_char *buff, u_char *value);
void dns4me_dec(u_char *password);



int main(void) {
    HKEY    key;
    u_char  buff[BUFFSZ + 1];


    setbuf(stdout, NULL);

    fputs("\n"
        "DNS4ME Client proxy password decoder "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    if(RegOpenKeyEx(HKEY_LOCAL_MACHINE, KEYPATH1, 0, KEY_READ, &key)) {
        fputs("\nError: registry key has not been found\n", stdout);
        fputs("\n    Press RETURN to exit\n", stdout);
        fgetc(stdin);
        exit(1);
    }

    doquery(key, buff, "Name");
    printf("Host:       %s:", buff);
    doquery(key, buff, "Port");
    printf("%d\n", *(int *)buff);
    doquery(key, buff, "Username");
    printf("Username:   %s\n", buff);
    doquery(key, buff, "Password");
    dns4me_dec(buff);
    printf("Password:   %s\n", buff);

    RegCloseKey(key);

    fputs("\n    Press RETURN to exit\n", stdout);
    fgetc(stdin);
    return(0);
}



void doquery(HKEY key, u_char *buff, u_char *value) {
    int     len = BUFFSZ;

    if(RegQueryValueEx(
      key,
      value,
      NULL,
      NULL,
      buff,
      (void *)&len)) {
        fputs("\nError: impossible to read the registry key\n", stdout);
        fputs("\n    Press RETURN to exit\n", stdout);
        fgetc(stdin);
        exit(1);
    }
}


    // the algorithm is the SAME of AllegroSurf!!!
void dns4me_dec(u_char *password) {
    u_int  tmp0,
            tmp1,
            tmp2,
            tmp3,
            eax,
            pwd1,
            pwd0,
            azz,
            *pwd,
            *encdata;
    int     len,
            lentmp,
            num;
    u_char  *ptr,
            *out;

    len = strlen(password);
    ptr = out = password;
    lentmp = len >> 1;
    while(lentmp--) {
        sscanf(ptr, "%02x", &num);
        *out++ = num;
        ptr += 2;
    }

    out = password;
    pwd = (u_int *)password;
    encdata = (u_int *)DNS4ME_PROXY_DATA;
    len >>= 4;
    while(len--) {
        azz = 0xc6ef3720;
        pwd0 = pwd[0];
        pwd1 = pwd[1];
        tmp0 = encdata[0];
        tmp1 = encdata[1];
        tmp2 = encdata[2];
        tmp3 = encdata[3];
        num = 32;
        while(num--) {
            eax = ((pwd0 >> 5) + tmp3) ^ ((pwd0 << 4) + tmp2);
            pwd1 -= (eax ^ (azz + pwd0));
            eax = ((pwd1 >> 5) + tmp1) ^ ((pwd1 << 4) + tmp0);
            pwd0 -= (eax ^ (azz + pwd1));
            azz += 0x61c88647;
        }
        *out++ = pwd0;
        pwd += 2;
    }
    *out = 0;
}


